/* Segundo Trabalho ED2
    Pontificia Universidade Catolica - Campinas

	Funcionamento:
		-Gera um arquivo com 3 campos randomicamente sem repeticoes no campo uid
			int uid
			char type
			chat label
		-Pelos metodos quicksort e bolha ele organiza de acordo com o campo uid
		-Default 2000 campos

	Cesar Henrique Kallas	opensrc@gmx.net		RA 02099224
	Willian Gimenez		RA ?
	
	Atualizado em 30/04/2003 - 14:10h (cesar)
	
*/	
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#define MAX 2000	//numero maximo de campos a ser gerado

struct user {
	int uid;
	char label[25];
	char type[4];
};

int verifica(struct user *teste,int i,int numero){

	int j;
	for(j=0;j<i;j++)
		if(teste[j].uid==numero)
		return false;
		
	return true;
	
}

void gravar (struct user *id,int opcao)
{
	FILE* arquivo;
	int i;
	if(opcao==1) { arquivo=fopen("ARQ1.dat","w");	cout << "\nARQ1 com sucesso\n"; }
	if(opcao==2) { arquivo=fopen("ARQ2.dat","w");	cout << "\nARQ2 com sucesso\n"; }
	if(opcao==3) { arquivo=fopen("ARQ3.dat","w");	cout << "\nARQ3 com sucesso\n"; }
	
	if (arquivo==NULL){
		cout<<"Erro ao gravar !\n";
		system("sleep 5");
	}
	else
		fwrite(&id[0],sizeof(struct user),MAX,arquivo);
			
	fclose(arquivo);
}

void gerar_arquivo(struct user *id){
	int i=0,j,numero,cont=0;
	char alfabeto[50];
	strcpy(alfabeto," m q ws5x 6c7sik,sd fg&(2)slM &@-+mnxbq sfghjyfde");
	
	while(i<MAX){
		//srand(time(NULL));
		numero = rand()%9999;
								
		if(verifica(id,i,numero)){
			
			/* Gera o ID do usuario, caso ele ainda nao existe eh aceito */
			id[i].uid=numero;
			
			/*Gera Label do usuario (provavel repeticao */
			
			numero = (rand() % 12);
			j=24-numero;
			strcpy(id[i].label,"");
			strncat(id[i].label,alfabeto,numero);
			strncat(id[i].label,alfabeto,j); 
			
			/* Gera o tipo de usuario */
			if(id[i].uid < 9999/6) strcpy(id[i].type,"user"); 
			if(id[i].uid > 9999/6 && id[i].uid < 9999/4) strcpy(id[i].type,"rmte");
			if(id[i].uid > 9999/4 && id[i].uid < 9999/2) strcpy(id[i].type,"supt");
			if(id[i].uid > 9999/2) strcpy(id[i].type,"outr");
			i++;
		}
	}
	
	for(i=0;i<MAX;i++)
		cout << "\n" << id[i].uid << "\t" << id[i].label << "\t" << id[i].type;
	
	cout << "\ngerados = " << i << "\n";
	gravar(id,1);
}

void ler_arquivo (struct user *id,int opcao)
{
	FILE* arquivo;
	if(opcao==1)	arquivo=fopen("ARQ1.dat","r");
	if(opcao==2)	arquivo=fopen("ARQ2.dat","r");
	if(opcao==3)	arquivo=fopen("ARQ3.dat","r");
	if(opcao==4)	arquivo=fopen("ARQ1.dat","r");
	
	if(arquivo==NULL){
		cout << "Falha ao abrir arquivo !";
		system("sleep 5");
	}
	else	
		fread(&id[0],sizeof(struct user),MAX,arquivo);
	fclose(arquivo);
	
	if(opcao!=4)
	for(int i=0;i<MAX;i++)
		cout << "\n" << id[i].uid << "\t" << id[i].label << "\t" << id[i].type;
}

void bolha(struct user *id){
	
	struct user *aux;
	aux = new struct user;
	int i,j;
	int teste=1;
	
	for(i=0;i<MAX-1 && teste==1;i++){
		teste=0;
		for(j=0;j<MAX-i-1;j++){
			if(id[j].uid>id[j+1].uid){
				teste=1;
				*aux=id[j];
				id[j]=id[j+1];
				id[j+1]=*aux;
			}
		}
	}
	gravar(id,2);
}

void quicksort(struct user *id,struct user *aux,int ini,int fim){
	
	int flag=1,i,j;
			
	if(ini<fim){
		i=ini;
		j=fim;
		while(i<j){
			if(id[i].uid > id[j].uid){
				*aux = id[i];
				id[i] = id[j];
				id[j] = *aux;
				flag=flag*(-1);
			}
			if(flag==1) j--;
				else
				i++;
		}
		quicksort(id,aux,ini,j-1);
		quicksort(id,aux,j+1,fim);
	}
}
				
				
void arq23(struct user *id){
	
	struct user *aux,*id2,*id3;
	aux = new struct user;
	id2 = new struct user;
	id3 = new struct user;
	
	ler_arquivo(id,4);
	id2 = id3 = id;
	
	bolha(id2);		
	quicksort(id3,aux,0,MAX-1);
	gravar(id3,3);
}

int main() {

	struct user *id;
	id = new struct user[MAX];
	int opcao=9;	
		
	while(opcao!=0){
		cout << "\n\n1. Gerar arquivo ARQ1.dat";
		cout << "\n2. Ler arquivo ARQ1.dat";
		cout << "\n3. Gerar Bolha e Quicksort";
		cout << "\n4. Ler ARQ2.dat - Bolha";
		cout << "\n5. Ler ARQ3.dat - Quicksort";
		cout << "\n :";
		cin >> opcao;
		
		switch(opcao){
			case 1: gerar_arquivo(id);	break;
			case 2: ler_arquivo(id,1);	break;
			case 3: arq23(id);	break;
			case 4: ler_arquivo(id,2);	break;
			case 5: ler_arquivo(id,3);	break;
			case 0: break;
			default: cout << "\ninvalido";
		}
	}
}

